



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>pandas.DataFrame学习系列1——定义及属性</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">pandas.DataFrame学习系列1——定义及属性</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-14 17:15:23 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>定义：</strong></p>
<p>DataFrame是二维的、大小可变的、成分混合的、具有标签化坐标轴（行和列）的表数据结构。基于行和列标签进行计算。可以被看作是为序列对象（Series）提供的类似字典的一个容器，是pandas中主要的数据结构。</p>
<p><strong>形式：</strong></p>
<div>
<pre class="prettyprint linenums">class pandas.DataFrame(data=None, index=None, columns=None, dtype=None, copy=False)</pre>
</div>
<p><strong>参数含义：</strong></p>
<div>
<pre class="prettyprint linenums">data : numpy ndarray（多维数组）（结构化或同质化的）, dict（字典）, or DataFrame（数据表）如果是字典类型，该字典可以包含序列，数组，常量或类列表型对象</pre>
<pre class="prettyprint linenums">index : Index or array-like 索引或数组类型，如果输入数据中没有索引信息以及没有提供索引时默认赋值为arange(n)即从0开始的等差数组<br />
columns : Index or array-like 索引或数组类型，没有提供列标签时默认赋值为0开始的等差数组<br />
dtype : dtype, default None 数据类型，默认为空。只允许有一种数据类型，如果为空，自动推断类型<br />
copy : boolean, default False 布尔类型，默认为False。从输入值中拷贝数据，只对输入为DataFrame或者二维数组时有影响</pre>
</div>
<p><strong>其他构建DataFrame类型的方法：</strong></p>
<div>
<pre class="prettyprint linenums">classmethod DataFrame.from_records(data, index=None, exclude=None, columns=None, coerce_float=False, nrows=None)[source]

classmethod DataFrame.from_dict(data, orient='columns', dtype=None)

<code><a href="http://pandas.pydata.org/pandas-docs/stable/generated/pandas.read_csv.html#pandas.read_csv" rel="external nofollow noreferrer">p</a>andas.read_csv</code>,&nbsp;pandas.read_table,&nbsp;<code>pandas.read_clipboard,pandas.read_excel等<br /></code></pre>
</div>
<p><strong>&nbsp;举例：</strong></p>
<div>
<pre class="prettyprint linenums">从字典构建DataFrame<br />&gt;&gt;&gt; d = {'col1': [1, 2], 'col2': [3, 4]}<br />
&gt;&gt;&gt; df = pd.DataFrame(data=d)<br />
&gt;&gt;&gt; df<br />
   col1  col2<br />
0     1     3<br />
1     2     4</pre>
</div>
<div>
<pre class="prettyprint linenums">推断类型为int64<br />&gt;&gt;&gt; df.dtypes<br />
col1    int64<br />
col2    int64<br />
dtype: object</pre>
</div>
<div>
<pre class="prettyprint linenums">强制设置为单一类型<br />
&gt;&gt;&gt; df = pd.DataFrame(data=d, dtype=np.int8)<br />
&gt;&gt;&gt; df.dtypes<br />
col1    int8<br />
col2    int8<br />
dtype: object</pre>
</div>
<div>
<pre class="prettyprint linenums">从numpy多维数组类型构建DataFrame<br />
&gt;&gt;&gt; df2 = pd.DataFrame(np.random.randint(low=0, high=10, size=(5, 5)),<br />
...                    columns=['a', 'b', 'c', 'd', 'e'])<br />
&gt;&gt;&gt; df2<br />
    a   b   c   d   e<br />
0   2   8   8   3   4<br />
1   4   2   9   0   9<br />
2   1   0   7   8   0<br />
3   5   1   7   1   3<br />
4   6   0   2   4   2</pre>
</div>
<p><strong>属性：</strong></p>
<p>获取和创建DataFrame</p>
<div>
<pre class="prettyprint linenums"> import pandas as pd<br />
 import numpy as np

 df=pd.read_excel('南京银行.xlsx',index_col='Date')<br />
 df1=df[:5]

 In [38]:df1.head()<br />
 Out[38]:<br />
          Open  High   Low  Close  Turnover    Volume<br />
 Date<br />
 2017-09-15  8.06  8.08  8.03   8.04    195.43  24272800<br />
 2017-09-18  8.05  8.13  8.03   8.06    200.76  24867600<br />
 2017-09-19  8.03  8.06  7.94   8.00    433.76  54253100<br />
 2017-09-20  7.97  8.06  7.95   8.03    319.94  39909700<br />
 2017-09-21  8.02  8.10  7.99   8.04    241.94  30056600</pre>
</div>
<p>--转置，转置以后DataFrame的index属性值为None</p>
<div>
<pre class="prettyprint linenums"> In [39]:  df1.T<br />
 Out[39]:<br />
 Date       2017-09-15   2017-09-18   2017-09-19   2017-09-20   2017-09-21<br />
 Open             8.06         8.05         8.03         7.97         8.02<br />
 High             8.08         8.13         8.06         8.06         8.10<br />
 Low              8.03         8.03         7.94         7.95         7.99<br />
 Close            8.04         8.06         8.00         8.03         8.04<br />
 Turnover       195.43       200.76       433.76       319.94       241.94<br />
 Volume    24272800.00  24867600.00  54253100.00  39909700.00  30056600.00</pre>
</div>
<p>--基于标签快速访问</p>
<div>
<pre class="prettyprint linenums">In [35]:  date=pd.to_datetime('2017-09-15')<br />
In [36]:  date<br />
Out[36]: Timestamp('2017-09-15 00:00:00')<br />
In [37]:  df1.at[date,'Open']<br />
Out[37]: 8.0600000000000005</pre>
</div>
<p>--获取行轴和列轴标签名</p>
<div>
<pre class="prettyprint linenums"> In [44]: df1.axes<br />
 Out[44]:<br />
 [DatetimeIndex(['2017-09-15', '2017-09-18', '2017-09-19', '2017-09-20',<br />
                 '2017-09-21'], dtype='datetime64[ns]', name='Date', freq=None),<br />
  Index(['Open', 'High', 'Low', 'Close', 'Turnover', 'Volume'], dtype='object')]</pre>
</div>
<p>--内置属性</p>
<div>
<pre class="prettyprint linenums"> In[45]: df1.blocks<br />
 Out[45]:<br />
 {'float64':     Open  High   Low  Close  Turnover<br />
  Date<br />
  2017-09-15  8.06  8.08  8.03   8.04    195.43<br />
  2017-09-18  8.05  8.13  8.03   8.06    200.76<br />
  2017-09-19  8.03  8.06  7.94   8.00    433.76<br />
  2017-09-20  7.97  8.06  7.95   8.03    319.94<br />
  2017-09-21  8.02  8.10  7.99   8.04    241.94,<br />
  'int64':               Volume<br />
  Date<br />
  2017-09-15  24272800<br />
  2017-09-18  24867600<br />
  2017-09-19  54253100<br />
  2017-09-20  39909700<br />
  2017-09-21  30056600}</pre>
</div>
<p>--各列数据类型</p>
<div>
<pre class="prettyprint linenums"> In[46]:  df1.dtypes<br />
 Out[46]:<br />
 Open        float64<br />
 High        float64<br />
 Low         float64<br />
 Close       float64<br />
 Turnover    float64<br />
 Volume        int64<br />
 dtype: object</pre>
</div>
<p>--判断DataFrame是否完全为空</p>
<div>
<pre class="prettyprint linenums"> In [47]: df1.empty<br />
 Out[47]: False</pre>
</div>
<p>--返回稀疏或密集的标示及数据类型</p>
<div>
<pre class="prettyprint linenums"> In[48]:  df1.ftypes<br />
 Out[48]:<br />
 Open        float64:dense<br />
 High        float64:dense<br />
 Low         float64:dense<br />
 Close       float64:dense<br />
 Turnover    float64:dense<br />
 Volume        int64:dense<br />
 dtype: object</pre>
</div>
<p>--快速整数标量定位（到具体元素，相当于给出坐标）</p>
<div>
<pre class="prettyprint linenums"> In[49]:  df1.iat[0,1] #第1行，第2列<br />
 Out[49]: 8.0800000000000001

 In[50]:  df1.iat[1,0] #第2行，第1列<br />
 Out[50]: 8.0500000000000007</pre>
</div>
<p>--用于位置选择的基于整数定位的索引（切片）</p>
<div>
<pre class="prettyprint linenums"> In []:  df1.iloc[:]<br />
 Out[]:<br />
             Open  High   Low  Close  Turnover    Volume<br />
 Date<br />
 --  8.06  8.08  8.03   8.04    195.43  </pre>
</div>
<div>
<pre class="prettyprint linenums"> In []:  df1.iloc[:,:]<br />
 Out[]:<br />
              Low  Close  Turnover    Volume<br />
 Date<br />
 --  8.03   8.04    195.43  </pre>
</div>
<p>--混合方式定位（基于整数位置或标签名以及它们的组合，可以只用行标签，但是不能只用列标签）</p>
<div>
<pre class="prettyprint linenums"> In []:  df1.ix[,'Open']<br />
 Out[]: 8.0500000000000007</pre>
</div>
<div>
<pre class="prettyprint linenums"> In []:  df1.ix[]<br />
 Out[]:<br />
 Open               8.05<br />
 High               8.13<br />
 Low                8.03<br />
 Close              8.06<br />
 Turnover         200.76<br />
 Volume      24867600.00<br />
 Name: -- ::, dtype: float64</pre>
</div>
<p>--选择位置的基于标签名的索引</p>
<div>
<pre class="prettyprint linenums"> In[7]:  df1.loc[date,'Low']<br />
 Out[7]: 8.0299999999999994

 In [8]: df1.loc[df1.index[0],'Low']<br />
 Out[8]: 8.0299999999999994</pre>
</div>
<p>--坐标轴个数</p>
<div>
<pre class="prettyprint linenums"> In [10]: df1.ndim<br />
 Out[10]: 2</pre>
</div>
<p>--DataFrame的形状（行列数）</p>
<div>
<pre class="prettyprint linenums"> In [11]:  df1.shape<br />
 Out[11]: (5, 6)</pre>
</div>
<p>--DataFrame的大小（元素个数）</p>
<div>
<pre class="prettyprint linenums"> In [12]:  df1.size<br />
 Out[12]: 30</pre>
</div>
<p>--返回DataFrame样式对象</p>
<div>
<pre class="prettyprint linenums"> In [13]:  df1.style<br />
 Out[13]: &lt;pandas.io.formats.style.Styler at 0x1c410cf8eb8&gt;</pre>
</div>
<p>--返回DataFrame里的数值（二维数组）</p>
<div>
<pre class="prettyprint linenums"> In [14]: df1.values<br />
 Out[14]:<br />
 array([[  8.06000000e+00,   8.08000000e+00,   8.03000000e+00,<br />
           8.04000000e+00,   1.95430000e+02,   2.42728000e+07],<br />
        [  8.05000000e+00,   8.13000000e+00,   8.03000000e+00,<br />
           8.06000000e+00,   2.00760000e+02,   2.48676000e+07],<br />
        [  8.03000000e+00,   8.06000000e+00,   7.94000000e+00,<br />
           8.00000000e+00,   4.33760000e+02,   5.42531000e+07],<br />
        [  7.97000000e+00,   8.06000000e+00,   7.95000000e+00,<br />
           8.03000000e+00,   3.19940000e+02,   3.99097000e+07],<br />
        [  8.02000000e+00,   8.10000000e+00,   7.99000000e+00,<br />
           8.04000000e+00,   2.41940000e+02,   3.00566000e+07]])</pre>
</div>
<p><strong>以上为DataFrame的主要属性，后面继续介绍DataFrame的方法。</strong></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7mzvkq.html">了解JavaScript 对象属性的标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxkjnd8.html">pyqt的信号槽机制（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o3wgp8.html">linux-10 基本命令之查看内存使用情况- free，history&comma;who&comma;last</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rpw4e8.html">BroadCast&comma;BroadCastReceiver</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q764018.html">hdu 1049 Climbing Worm</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vdlzo8.html">Jenkins最佳实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmk0l09.html">iOS 相机和相册使用授权</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1gzej9.html">单点登录CAS使用记（七）：关于服务器超时以及客户端超时的分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz16x48.html">smartcn与IKanalyzer</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j0n7v8.html">自适应滤波：维纳滤波器&mdash;&mdash;GSC算法及语音增强</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg610r8.html">通过createObjectURL实现图片预览</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mexxn6q.html">JDK 1&period;8 源码阅读和理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eykylk9.html">&lbrack;bzoj4815&rsqb;&colon; &lbrack;Cqoi2017&rsqb;小Q的表格</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rv2039.html">&lbrack;C&num; 基础知识系列&rsqb;专题五：当点击按钮时触发Click事件背后发生的事情 （转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2yr26q.html">Linux下不停止服务&comma;清空nohup&period;out文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv0rgx8.html">luogu3203 弹飞绵羊 &lpar;LCT&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25e0elq.html">潭州课堂25班：Ph201805201 爬虫基础 第十课 图像处理- 极验验证码 &lpar;课堂笔记）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4kryk9.html">vsftpd上传文件出现553 Could not create file错误解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25lwp3q.html">unity3d-游戏实战突出重围，第三天 绘制数字</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp3lxl9.html">qt&mdash;&mdash;QT中QWidget、QDialog及QMainWindow的区别</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdpg1k7q.html">SQL Server安装【转载】</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj3p7xq.html">temp-内外网同时上的例子</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pln348.html">Java Annotation注解继承说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4z713e9.html">Sping IOC</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y32y08.html">Android 之内容提供者 内容解析者 内容观察者</a>
			</li>
						<li><a href="https://www.batexi.com/a/950zkdv8.html">Cheat sheet for Jupyter Notebook</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mey5npq.html">JavaScript 框架------------AngularJS（上）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meygepq.html">使用python实现后台系统的JWT认证&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z2p1g9.html">vue2组件之select2调用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meyo70q.html">C-一行或多行文章垂直居中</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
